use super::schema::simulation_behaviors;
use diesel::prelude::*;
/// Mobility Behavior
/// ---
///
/// Including a MobilityRecord from CSV extraction
///
#[derive(Queryable, Selectable)]
#[diesel(table_name = simulation_behaviors)]
#[diesel(check_for_backend(diesel::sqlite::Sqlite))]
pub struct SimulationBehavior {
    pub id: i32,
    pub dataset_id: i32,
    pub relative_start_time: i32,
    pub quantity: String,
    pub mobility_record: Vec<u8>,
}

#[derive(Insertable)]
#[diesel(table_name = simulation_behaviors)]
pub struct NewSimulationBehavior<'a> {
    pub dataset_id: &'a i32,
    pub relative_start_time: &'a i32,
    pub quantity: &'a String,
    pub mobility_record: &'a Vec<u8>,
}
